## olm 3.2.10~dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(olm VERSION 3.2.10 LANGUAGES CXX C)

option(OLM_TESTS "Build tests" ON)
option(BUILD_SHARED_LIBS "Build as a shared library" ON)

add_definitions(-DOLMLIB_VERSION_MAJOR=${PROJECT_VERSION_MAJOR})
add_definitions(-DOLMLIB_VERSION_MINOR=${PROJECT_VERSION_MINOR})
add_definitions(-DOLMLIB_VERSION_PATCH=${PROJECT_VERSION_PATCH})

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

add_library(olm
    src/account.cpp
    src/base64.cpp
    src/cipher.cpp
    src/crypto.cpp
    src/memory.cpp
    src/message.cpp
    src/pickle.cpp
    src/ratchet.cpp
    src/session.cpp
    src/utility.cpp
    src/pk.cpp
    src/sas.c

    src/ed25519.c
    src/error.c
    src/inbound_group_session.c
    src/megolm.c
    src/olm.cpp
    src/outbound_group_session.c
    src/pickle_encoding.c

    lib/crypto-algorithms/aes.c
    lib/crypto-algorithms/sha256.c
    lib/curve25519-donna/curve25519-donna.c)
add_library(Olm::Olm ALIAS olm)

# restrict the exported symbols
include(GenerateExportHeader)
generate_export_header(olm
  EXPORT_FILE_NAME ${CMAKE_CURRENT_SOURCE_DIR}/include/olm/olm_export.h)

target_include_directories(olm
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/lib)

set_target_properties(olm PROPERTIES
   SOVERSION ${PROJECT_VERSION_MAJOR}
   VERSION ${PROJECT_VERSION})

set_target_properties(olm PROPERTIES
    ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

include(GNUInstallDirs)

# Make a pkg-config file
configure_file(${PROJECT_NAME}.pc.in ${PROJECT_NAME}.pc @ONLY NEWLINE_STYLE UNIX)

#
# Installation
#
set(INSTALL_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/Olm)
install(TARGETS olm
    EXPORT olm-targets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

# The exported target will be named Olm.
set_target_properties(olm PROPERTIES EXPORT_NAME Olm)
install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/include/olm/olm.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/olm/olm_export.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/olm/outbound_group_session.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/olm/inbound_group_session.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/olm/pk.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/olm/sas.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/olm/error.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/olm)

if (UNIX AND NOT APPLE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    )
endif ()

# Export the targets to a script.
install(EXPORT olm-targets
  FILE OlmTargets.cmake
  NAMESPACE Olm::
  DESTINATION ${INSTALL_CONFIGDIR})

# Create a ConfigVersion.cmake file.
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/OlmConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion)

configure_package_config_file(
    ${CMAKE_CURRENT_LIST_DIR}/cmake/OlmConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/OlmConfig.cmake
    INSTALL_DESTINATION ${INSTALL_CONFIGDIR})

#Install the config & configversion.
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/OlmConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/OlmConfigVersion.cmake
    DESTINATION ${INSTALL_CONFIGDIR})

# Register package in user's package registry
export(EXPORT olm-targets
    FILE ${CMAKE_CURRENT_BINARY_DIR}/OlmTargets.cmake
    NAMESPACE Olm::)
export(PACKAGE Olm)

if (OLM_TESTS)
   add_subdirectory(tests)
endif()

=== Makefile ===
#!/usr/bin/make -f

include common.mk
VERSION := $(MAJOR).$(MINOR).$(PATCH)
PREFIX ?= /usr/local
BUILD_DIR := build
RELEASE_OPTIMIZE_FLAGS ?= -O3
DEBUG_OPTIMIZE_FLAGS ?= -g -O0
JS_OPTIMIZE_FLAGS ?= -O3
FUZZER_OPTIMIZE_FLAGS ?= -O3
CC = gcc
EMCC = emcc
EMAR = emar
AR = ar

UNAME := $(shell uname)
ifeq ($(UNAME),Darwin)
	SO := dylib
	OLM_LDFLAGS :=
else
	SO := so
	OLM_LDFLAGS := -Wl,-soname,libolm.so.$(MAJOR) \
                       -Wl,--version-script,version_script.ver
endif

RELEASE_TARGET := $(BUILD_DIR)/libolm.$(SO).$(VERSION)
STATIC_RELEASE_TARGET := $(BUILD_DIR)/libolm.a
DEBUG_TARGET := $(BUILD_DIR)/libolm_debug.$(SO).$(VERSION)
JS_WASM_TARGET := javascript/olm.js
JS_ASMJS_TARGET := javascript/olm_legacy.js
WASM_TARGET := $(BUILD_DIR)/wasm/libolm.a

JS_EXPORTED_FUNCTIONS := javascript/exported_functions.json
JS_EXPORTED_RUNTIME_METHODS := [ALLOC_STACK]
JS_EXTERNS := javascript/externs.js

PUBLIC_HEADERS := include/olm/olm.h include/olm/outbound_group_session.h include/olm/inbound_group_session.h include/olm/pk.h include/olm/sas.h include/olm/error.h include/olm/olm_export.h

SOURCES := $(wildcard src/*.cpp) $(wildcard src/*.c) \
    lib/crypto-algorithms/sha256.c \
    lib/crypto-algorithms/aes.c \
    lib/curve25519-donna/curve25519-donna.c

FUZZER_SOURCES := $(wildcard fuzzing/fuzzers/fuzz_*.cpp) $(wildcard fuzzing/fuzzers/fuzz_*.c)
TEST_SOURCES := $(wildcard tests/test_*.cpp) $(wildcard tests/test_*.c)

OBJECTS := $(patsubst %.c,%.o,$(patsubst %.cpp,%.o,$(SOURCES)))
RELEASE_OBJECTS := $(addprefix $(BUILD_DIR)/release/,$(OBJECTS))
DEBUG_OBJECTS := $(addprefix $(BUILD_DIR)/debug/,$(OBJECTS))
FUZZER_OBJECTS := $(addprefix $(BUILD_DIR)/fuzzers/objects/,$(OBJECTS))
FUZZER_ASAN_OBJECTS := $(addprefix $(BUILD_DIR)/fuzzers/objects/,$(addprefix asan_,$(OBJECTS)))
FUZZER_MSAN_OBJECTS := $(addprefix $(BUILD_DIR)/fuzzers/objects/,$(addprefix msan_,$(OBJECTS)))
FUZZER_DEBUG_OBJECTS := $(addprefix $(BUILD_DIR)/fuzzers/objects/,$(addprefix debug_,$(OBJECTS)))
FUZZER_BINARIES := $(addprefix $(BUILD_DIR)/fuzzers/,$(basename $(notdir $(FUZZER_SOURCES))))
FUZZER_ASAN_BINARIES := $(addsuffix _asan,$(FUZZER_BINARIES))
FUZZER_MSAN_BINARIES := $(addsuffix _msan,$(FUZZER_BINARIES))
FUZZER_DEBUG_BINARIES := $(patsubst $(BUILD_DIR)/fuzzers/fuzz_%,$(BUILD_DIR)/fuzzers/debug_%,$(FUZZER_BINARIES))
TEST_BINARIES := $(patsubst tests/%,$(BUILD_DIR)/tests/%,$(basename $(TEST_SOURCES)))
JS_OBJECTS := $(addprefix $(BUILD_DIR)/javascript/,$(OBJECTS))
WASM_OBJECTS := $(addprefix $(BUILD_DIR)/wasm/,$(OBJECTS))

# pre & post are the js-pre/js-post options to emcc.
# They are injected inside the modularised code and
# processed by the optimiser.
JS_PRE := $(wildcard javascript/*pre.js)
JS_POST := javascript/olm_outbound_group_session.js \
    javascript/olm_inbound_group_session.js \
    javascript/olm_pk.js \
    javascript/olm_sas.js \
    javascript/olm_post.js

# The prefix & suffix are just added onto the start & end
# of what comes out emcc, so are outside of the modularised
# code and not seen by the opimiser.
JS_PREFIX := javascript/olm_prefix.js
JS_SUFFIX := javascript/olm_suffix.js

DOCS := tracing/README.html \
    docs/megolm.html \
    docs/olm.html \
    docs/signing.html \
    README.html \
    CHANGELOG.html

CPPFLAGS += -Iinclude -Ilib \
    -DOLMLIB_VERSION_MAJOR=$(MAJOR) -DOLMLIB_VERSION_MINOR=$(MINOR) \
    -DOLMLIB_VERSION_PATCH=$(PATCH)

# we rely on <stdint.h>, which was introduced in C99
CFLAGS += -Wall -Werror -std=c99
CXXFLAGS += -Wall -Werror -std=c++11
LDFLAGS += -Wall -Werror

CFLAGS_NATIVE = -fPIC
CXXFLAGS_NATIVE = -fPIC

EMCCFLAGS = --closure 1 --memory-init-file 0 -s NO_FILESYSTEM=1 -s INVOKE_RUN=0 -s MODULARIZE=1

# Olm generally doesn't need a lot of memory to encrypt / decrypt its usual
# payloads (ie. Matrix messages), but we do need about 128K of heap to encrypt
# a 64K event (enough to store the ciphertext and the plaintext, bearing in
# mind that the plaintext can only be 48K because base64). We also have about
# 36K of statics. So let's have 256K of memory.
# (This can't be changed by the app with wasm since it's baked into the wasm).
# (emscripten also mandates at least 16MB of memory for asm.js now, so
# we don't use this for the legacy build.)
EMCCFLAGS_WASM += -s TOTAL_STACK=65536 -s TOTAL_MEMORY=262144

EMCCFLAGS_ASMJS += -s WASM=0

EMCC.c = $(EMCC) $(CFLAGS) $(CPPFLAGS) -c -DNDEBUG -DOLM_STATIC_DEFINE=1
EMCC.cc = $(EMCC) $(CXXFLAGS) $(CPPFLAGS) -c -DNDEBUG -DOLM_STATIC_DEFINE=1
EMCC_LINK = $(EMCC) $(LDFLAGS) $(EMCCFLAGS)

AFL_CC = afl-clang-fast
AFL_CXX = afl-clang-fast++

AFL.c = $(AFL_CC) $(CFLAGS) $(CPPFLAGS) -c
AFL.cc = $(AFL_CXX) $(CXXFLAGS) $(CPPFLAGS) -c
AFL_LINK.c = $(AFL_CC) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)
AFL_LINK.cc = $(AFL_CXX) $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS)
AFL_ASAN.c = AFL_USE_ASAN=1 $(AFL_CC) -m32 $(CFLAGS) $(CPPFLAGS) -c
AFL_ASAN.cc = AFL_USE_ASAN=1 $(AFL_CXX) -m32 $(CXXFLAGS) $(CPPFLAGS) -c
AFL_LINK_ASAN.c = AFL_USE_ASAN=1 $(AFL_CC) -m32 $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)
AFL_LINK_ASAN.cc = AFL_USE_ASAN=1 $(AFL_CXX) -m32 $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS)
AFL_MSAN.c = AFL_USE_MSAN=1 $(AFL_CC) $(CFLAGS) $(CPPFLAGS) -c
AFL_MSAN.cc = AFL_USE_MSAN=1 $(AFL_CXX) $(CXXFLAGS) $(CPPFLAGS) -c
AFL_LINK_MSAN.c = AFL_USE_MSAN=1 $(AFL_CC) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS)
AFL_LINK_MSAN.cc = AFL_USE_MSAN=1 $(AFL_CXX) $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS)

# generate .d files when compiling
CPPFLAGS += -MMD

### per-target variables

$(RELEASE_OBJECTS): CFLAGS += $(RELEASE_OPTIMIZE_FLAGS) $(CFLAGS_NATIVE)
$(RELEASE_OBJECTS): CXXFLAGS += $(RELEASE_OPTIMIZE_FLAGS) $(CXXFLAGS_NATIVE)
$(RELEASE_TARGET): LDFLAGS += $(RELEASE_OPTIMIZE_FLAGS)

$(DEBUG_OBJECTS): CFLAGS += $(DEBUG_OPTIMIZE_FLAGS) $(CFLAGS_NATIVE)
$(DEBUG_OBJECTS): CXXFLAGS += $(DEBUG_OPTIMIZE_FLAGS) $(CXXFLAGS_NATIVE)
$(DEBUG_TARGET): LDFLAGS += $(DEBUG_OPTIMIZE_FLAGS)

$(TEST_BINARIES): CPPFLAGS += -Itests/include
$(TEST_BINARIES): LDFLAGS += $(DEBUG_OPTIMIZE_FLAGS) -L$(BUILD_DIR)

$(FUZZER_OBJECTS): CFLAGS += $(FUZZER_OPTIMIZE_FLAGS) -D OLM_FUZZING=1
$(FUZZER_OBJECTS): CXXFLAGS += $(FUZZER_OPTIMIZE_FLAGS) -D OLM_FUZZING=1
$(FUZZER_DEBUG_OBJECTS): CFLAGS += $(DEBUG_OPTIMIZE_FLAGS) $(CFLAGS_NATIVE) -D OLM_FUZZING=1
$(FUZZER_DEBUG_OBJECTS): CXXFLAGS += $(DEBUG_OPTIMIZE_FLAGS) $(CXXFLAGS_NATIVE) -D OLM_FUZZING=1
$(FUZZER_ASAN_OBJECTS): CFLAGS += $(FUZZER_OPTIMIZE_FLAGS) -D OLM_FUZZING=1
$(FUZZER_ASAN_OBJECTS): CXXFLAGS += $(FUZZER_OPTIMIZE_FLAGS) -D OLM_FUZZING=1
$(FUZZER_MSAN_OBJECTS): CFLAGS += $(FUZZER_OPTIMIZE_FLAGS) -D OLM_FUZZING=1
$(FUZZER_MSAN_OBJECTS): CXXFLAGS += $(FUZZER_OPTIMIZE_FLAGS) -D OLM_FUZZING=1

$(FUZZER_BINARIES): CPPFLAGS += -Ifuzzing/fuzzers/include
$(FUZZER_BINARIES): LDFLAGS += $(FUZZER_OPTIMIZE_FLAGS) -L$(BUILD_DIR) -lstdc++
$(FUZZER_ASAN_BINARIES): CPPFLAGS += -Ifuzzing/fuzzers/include
$(FUZZER_ASAN_BINARIES): LDFLAGS += $(FUZZER_OPTIMIZE_FLAGS) -L$(BUILD_DIR) -lstdc++
$(FUZZER_MSAN_BINARIES): CPPFLAGS += -Ifuzzing/fuzzers/include
$(FUZZER_MSAN_BINARIES): LDFLAGS += $(FUZZER_OPTIMIZE_FLAGS) -L$(BUILD_DIR) -lstdc++
$(FUZZER_DEBUG_BINARIES): CPPFLAGS += -Ifuzzing/fuzzers/include
$(FUZZER_DEBUG_BINARIES): LDFLAGS += $(DEBUG_OPTIMIZE_FLAGS) -lstdc++

$(JS_OBJECTS): CFLAGS += $(JS_OPTIMIZE_FLAGS)
$(JS_OBJECTS): CXXFLAGS += $(JS_OPTIMIZE_FLAGS)
$(JS_WASM_TARGET): LDFLAGS += $(JS_OPTIMIZE_FLAGS)
$(JS_ASMJS_TARGET): LDFLAGS += $(JS_OPTIMIZE_FLAGS)

### Fix to make mkdir work on windows and linux
ifeq ($(shell echo "check_quotes"),"check_quotes")
   WINDOWS := yes
else
   WINDOWS := no
endif

ifeq ($(WINDOWS),yes)
   mkdir = mkdir $(subst /,\,$(1)) > nul 2>&1 || (exit 0)
else
   mkdir = mkdir -p $(1)
endif

### top-level targets

lib: $(RELEASE_TARGET)
.PHONY: lib

$(RELEASE_TARGET): $(RELEASE_OBJECTS)
	@echo
	@echo '****************************************************************************'
	@echo '* WARNING: Building olm with make is deprecated. Please use cmake instead. *'
	@echo '****************************************************************************'
	@echo

	$(CXX) $(LDFLAGS) --shared -fPIC \
            $(OLM_LDFLAGS) \
            $(OUTPUT_OPTION) $(RELEASE_OBJECTS)
	ln -sf libolm.$(SO).$(VERSION) $(BUILD_DIR)/libolm.$(SO).$(MAJOR)
	ln -sf libolm.$(SO).$(VERSION) $(BUILD_DIR)/libolm.$(SO)

debug: $(DEBUG_TARGET)
.PHONY: debug

$(DEBUG_TARGET): $(DEBUG_OBJECTS)
	$(CXX) $(LDFLAGS) --shared -fPIC \
            $(OLM_LDFLAGS) \
            $(OUTPUT_OPTION) $(DEBUG_OBJECTS)
	ln -sf libolm_debug.$(SO).$(VERSION) $(BUILD_DIR)/libolm_debug.$(SO).$(MAJOR)

static: $(STATIC_RELEASE_TARGET)
.PHONY: static

$(STATIC_RELEASE_TARGET): $(RELEASE_OBJECTS)
	$(AR) rcs $@ $^

js: $(JS_WASM_TARGET) $(JS_ASMJS_TARGET)
.PHONY: js

wasm: $(WASM_TARGET)
.PHONY: wasm

$(WASM_TARGET): $(WASM_OBJECTS)
	$(EMAR) rcs $@ $^

javascript/olm_prefix.js: javascript/olm_prefix.js.in Makefile common.mk
	sed s/@VERSION@/$(VERSION)/ javascript/olm_prefix.js.in > $@

# Note that the output file we give to emcc determines the name of the
# wasm file baked into the js, hence messing around outputting to olm.js
# and then renaming it.
$(JS_WASM_TARGET): $(JS_OBJECTS) $(JS_PRE) $(JS_POST) $(JS_EXPORTED_FUNCTIONS) $(JS_PREFIX) $(JS_SUFFIX)
	EMCC_CLOSURE_ARGS="--externs $(CURDIR)/$(JS_EXTERNS)" $(EMCC_LINK) \
	       $(EMCCFLAGS_WASM) \
               $(foreach f,$(JS_PRE),--pre-js $(f)) \
               $(foreach f,$(JS_POST),--post-js $(f)) \
               $(foreach f,$(JS_PREFIX),--extern-pre-js $(f)) \
               $(foreach f,$(JS_SUFFIX),--extern-post-js $(f)) \
               -s "EXPORTED_FUNCTIONS=@$(JS_EXPORTED_FUNCTIONS)" \
               -s "EXPORTED_RUNTIME_METHODS=$(JS_EXPORTED_RUNTIME_METHODS)" \
               -o $@ $(JS_OBJECTS)

$(JS_ASMJS_TARGET): $(JS_OBJECTS) $(JS_PRE) $(JS_POST) $(JS_EXPORTED_FUNCTIONS) $(JS_PREFIX) $(JS_SUFFIX)
	EMCC_CLOSURE_ARGS="--externs $(CURDIR)/$(JS_EXTERNS)" $(EMCC_LINK) \
	       $(EMCCFLAGS_ASMJS) \
               $(foreach f,$(JS_PRE),--pre-js $(f)) \
               $(foreach f,$(JS_POST),--post-js $(f)) \
               $(foreach f,$(JS_PREFIX),--extern-pre-js $(f)) \
               $(foreach f,$(JS_SUFFIX),--extern-post-js $(f)) \
               -s "EXPORTED_FUNCTIONS=@$(JS_EXPORTED_FUNCTIONS)" \
               -s "EXPORTED_RUNTIME_METHODS=$(JS_EXPORTED_RUNTIME_METHODS)" \
               -o $@ $(JS_OBJECTS)

build_tests: $(TEST_BINARIES)

test: build_tests
	for i in $(TEST_BINARIES); do \
	    echo $$i; \
	    $$i || exit $$?; \
	done

test_mem: build_tests
	for i in $(TEST_BINARIES); do \
	    echo $$i; \
	    valgrind -q --leak-check=yes --exit-on-first-error=yes --error-exitcode=1 $$i || exit $$?; \
	done

fuzzers: $(FUZZER_BINARIES) $(FUZZER_ASAN_BINARIES) $(FUZZER_MSAN_BINARIES) $(FUZZER_DEBUG_BINARIES)
.PHONY: fuzzers

$(JS_EXPORTED_FUNCTIONS): $(PUBLIC_HEADERS)
	./exports.py $^ > $@.tmp
	mv $@.tmp $@

all: test js lib debug doc
.PHONY: all

install-headers: $(PUBLIC_HEADERS)
	test -d $(DESTDIR)$(PREFIX)/include/olm || $(call mkdir,$(DESTDIR)$(PREFIX)/include/olm)
	install $(PUBLIC_HEADERS) $(DESTDIR)$(PREFIX)/include/olm/
.PHONY: install-headers

install-debug: debug install-headers
	test -d $(DESTDIR)$(PREFIX)/lib || $(call mkdir,$(DESTDIR)$(PREFIX)/lib)
	install $(DEBUG_TARGET) $(DESTDIR)$(PREFIX)/lib/libolm_debug.$(SO).$(VERSION)
	ln -sf libolm_debug.$(SO).$(VERSION) $(DESTDIR)$(PREFIX)/lib/libolm_debug.$(SO).$(MAJOR)
	ln -sf libolm_debug.$(SO).$(VERSION) $(DESTDIR)$(PREFIX)/lib/libolm_debug.$(SO)
.PHONY: install-debug

install: lib install-headers
	test -d $(DESTDIR)$(PREFIX)/lib || $(call mkdir,$(DESTDIR)$(PREFIX)/lib)
	install $(RELEASE_TARGET) $(DESTDIR)$(PREFIX)/lib/libolm.$(SO).$(VERSION)
	ln -sf libolm.$(SO).$(VERSION) $(DESTDIR)$(PREFIX)/lib/libolm.$(SO).$(MAJOR)
	ln -sf libolm.$(SO).$(VERSION) $(DESTDIR)$(PREFIX)/lib/libolm.$(SO)
.PHONY: install

clean:;
	rm -rf $(BUILD_DIR) $(DOCS)
.PHONY: clean

doc: $(DOCS)
.PHONY: doc

### rules for building objects
$(BUILD_DIR)/release/%.o: %.c
	$(call mkdir,$(dir $@))

=== python/Makefile ===
all: olm-python3

OLM_HEADERS = ../include/olm/olm.h ../include/olm/inbound_group_session.h \
	      ../include/olm/outbound_group_session.h

include/olm/olm.h: $(OLM_HEADERS)
	mkdir -p include/olm
	$(CPP) -DOLM_STATIC_DEFINE -I dummy -I ../include -o include/olm/olm.h ../include/olm/olm.h
# add memset to the header so that we can use it to clear buffers
	echo 'void *memset(void *s, int c, size_t n);' >> include/olm/olm.h

include/olm/pk.h: include/olm/olm.h ../include/olm/pk.h
	$(CPP) -DOLM_STATIC_DEFINE -I dummy  -I ../include -o include/olm/pk.h ../include/olm/pk.h

include/olm/sas.h: include/olm/olm.h ../include/olm/sas.h
	$(CPP) -DOLM_STATIC_DEFINE -I dummy -I ../include -o include/olm/sas.h ../include/olm/sas.h

include/olm/error.h: include/olm/olm.h ../include/olm/error.h
	$(CPP) -DOLM_STATIC_DEFINE -I dummy -I ../include -o include/olm/error.h ../include/olm/error.h

headers: include/olm/olm.h include/olm/pk.h include/olm/sas.h include/olm/error.h

install: install-python3

install-python3: olm-python3
	python3 setup.py install --skip-build -O1 --root=$(DESTDIR)

test: olm-python3
	rm -rf install-temp
	mkdir -p install-temp/3
	PYTHONPATH=install-temp/3 python3 setup.py install --skip-build --install-lib install-temp/3 --install-script install-temp/bin
	PYTHONPATH=install-temp/3 python3 -m pytest
	PYTHONPATH=install-temp/3 python3 -m pytest --flake8 --benchmark-disable
	PYTHONPATH=install-temp/3 python3 -m pytest --isort --benchmark-disable
	PYTHONPATH=install-temp/3 python3 -m pytest --cov --cov-branch --benchmark-disable
	rm -rf install-temp

isort:
	isort -y -p olm

clean:
	rm -rf python_olm.egg-info/ dist/ __pycache__/
	rm -rf *.so _libolm.o
	rm -rf packages/
	rm -rf build/
	rm -rf install-temp/
	rm -rf include/

.PHONY: all olm-python3 install install-python3 clean test

=== debian/changelog ===
olm (3.2.10~dfsg-6ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't use Ubuntu LDFLAGS for wasm build,
      because they are incompatible with wasm, causing a build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Feb 2022 21:59:46 +0100

olm (3.2.10~dfsg-6) unstable; urgency=medium

  * fix check JavaScript tests only where Node.js is available

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 21 Feb 2022 11:25:19 +0100

olm (3.2.10~dfsg-5ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't use Ubuntu LDFLAGS for wasm build,
      because they are incompatible with wasm, causing a build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 17 Feb 2022 20:35:26 +0100

olm (3.2.10~dfsg-5) unstable; urgency=medium

  * check javascript tests;
    build-depend on node-jasmine
  * generate html and plaintext README for libjs-olm
    from upstream markdown
  * simplify building JavaScript code;
    tighten build-dependency on emscripten

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 17 Feb 2022 13:19:31 +0100

olm (3.2.10~dfsg-4ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Don't use Ubuntu LDFLAGS for wasm build,
      because they are incompatible with wasm, causing a build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Jan 2022 22:31:21 +0100

olm (3.2.10~dfsg-4) unstable; urgency=medium

  * set Rules-Requires-Root: no
  * use doctest as test runner:
    + drop patch 2003
    + build-depend on doctest-dev
  * build-depend on python3-pygments,
    to improve parsing of upstream ReST documentation

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 19 Jan 2022 09:48:11 +0100

olm (3.2.10~dfsg-3) unstable; urgency=medium

  * fix build html documentation in arch-dependent build

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 13 Jan 2022 23:29:03 +0100

olm (3.2.10~dfsg-2ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Don't use Ubuntu LDFLAGS for wasm build,
      because they are incompatible with wasm, causing a build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Jan 2022 22:44:43 +0100

olm (3.2.10~dfsg-2) unstable; urgency=medium

  * add patch 1001 to fix make target doc;
    thanks to Hubert Chathi
  * add patch 1002 to fix ReST syntax of upstream file CHANCHELOG.rst
  * build and install html documentation from ReST and Markdown sources;
    build-depend on python3-docutils pandoc;
    have libolm3-dev recommend libjs-katex
  * update TODOs

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 13 Jan 2022 22:09:50 +0100

olm (3.2.10~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * update copyright info:
    + avoid convenience code copy of doctest
      when repackaging upstream source
    + update coverage
  * rename and renumber patch
    1001_python3.patch -> 2002_python3_shebang.patch:
    Shrunk to only strip use of /usr/bin/env
    which is unlikely to be relevant upstream
  * add patch 2003 to avoid doctest for running testsuite

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 13 Jan 2022 13:18:56 +0100

olm (3.2.8~dfsg-1ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't use Ubuntu LDFLAGS for wasm build,
      because they are incompatible with wasm, causing a build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 15 Dec 2021 12:21:00 +0100

olm (3.2.8~dfsg-1) unstable; urgency=high

  [ upstream ]
  * new release

  * set urgency=high die to security bugfix;
    CVE-2021-44538

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 13 Dec 2021 19:23:42 +0100

olm (3.2.7~dfsg-2) unstable; urgency=medium

  * tighten lintian overrides
  * update symbols:
    + 3 public symbols added
    + 72 public symbols dropped (wrongly introduced in 3.2.6)
    + 1 private symbol dropped

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 07 Dec 2021 17:32:06 +0100

olm (3.2.7~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * use dpkg-provided make snippet (not direct dpkg-parsechangelog call)
    to resolve if release is experimental

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 07 Dec 2021 12:08:56 +0100

olm (3.2.6~dfsg-2) unstable; urgency=medium

  * update symbols file:
    many changes, including removal of public symbol olm_pk_cipher
    which is unused in all reverse dependencies in Debian
  * relax to build-depend unversioned on python3-all-dev:
    required version satisfied in all supported Debian releases

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 21 Sep 2021 13:31:17 +0200

olm (3.2.6~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * update copyright info:
    + use Reference field (not License-Reference);
      tighten lintian overrides
    + update coverage
    + list GitHub issue tracker as preferred upstream contact
    + update source URI
  * use semantic newlines in long description and copyright fields
  * update Homepage URI
  * drop patch cherry-picked upstream now applied
  * unfuzz patch 2001
  * add debian/patches/README documenting patch-naming micro-policy
  * relax symbols check when targeting experimental

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 19 Sep 2021 12:03:06 +0200

olm (3.2.4~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * declare compliance with Debian Policy 4.6.0
  * track library symbols; build-depend on pkg-kde-tools
  * stop pass -sASSERTIONS=1 to emscripten:
    uncertain why it was added,
    and apparently cause build failure with emscripten 2.0.26

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 23 Aug 2021 13:51:37 +0200

olm (3.2.3~dfsg-3) unstable; urgency=medium

  * fix URLs in DEP-3 headers of upstream cherry-picked patch
  * fix post-build cleanup

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 16 Aug 2021 17:16:05 +0200



=== debian/control ===
Source: olm
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders:
 Hubert Chathi <uhoreg@debian.org>,
 Jonas Smedegaard <dr@jones.dk>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 doctest-dev <!nocheck>,
 node-jasmine [amd64 arm64 armhf i386 mips64el mipsel ppc64 ppc64el s390x] <!nocheck>,
 pandoc,
 pkg-kde-tools,
 python3-all-dev,
 python3-cffi,
 python3-docutils,
 python3-future <!nocheck>,
 python3-pygments,
 python3-pytest <!nocheck>,
 python3-setuptools,
Build-Depends-Indep:
 brotli,
 dpkg (>= 1.20.1),
 emscripten (>= 3.1.4~),
 pigz,
 uglifyjs (>= 3),
Standards-Version: 4.6.0
Section: libs
Homepage: https://gitlab.matrix.org/matrix-org/olm/
Vcs-Git: https://salsa.debian.org/matrix-team/olm.git
Vcs-Browser: https://salsa.debian.org/matrix-team/olm
Rules-Requires-Root: no

Package: libolm3
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libjs-katex,
Conflicts:
 libolm2,
Replaces:
 libolm2,
Provides:
 libolm2,
Description: implementation of the Double Ratchet cryptographic ratchet in C++
 Olm is an implementation of the Double Ratchet cryptographic ratchet
 described by https://whispersystems.org/docs/specifications/doubleratchet/,
 written in C and C++11 and exposed as a C API.
 .
 This library also includes an implementation
 of the Megolm cryptographic ratchet
 which is intended for encrypted messaging applications
 where there may be a large number of recipients of each message,
 thus precluding the use of peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system
 for the Matrix communications protocol.
Multi-Arch: same

Package: libolm-dev
Section: libdevel
Architecture: any
Depends:
 libolm3 (= ${binary:Version}),
 pkg-config,
 ${misc:Depends},
Description: development files for the olm Double Ratchet implementation
 Olm is an implementation of the Double Ratchet cryptographic ratchet
 described by https://whispersystems.org/docs/specifications/doubleratchet/,
 written in C and C++11 and exposed as a C API.
 .
 This library also includes an implementation
 of the Megolm cryptographic ratchet
 which is intended for encrypted messaging applications
 where there may be a large number of recipients of each message,
 thus precluding the use of peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system
 for the Matrix communications protocol.
 .
 This package contains the development files
 for compiling programs that use olm.
Multi-Arch: same

Package: python3-olm
Section: python
Architecture: any
Depends:
 libolm3 (<< ${source:Version}.1~),
 libolm3 (>= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for the olm Double Ratchet implementation
 Olm is an implementation of the Double Ratchet cryptographic ratchet
 described by https://whispersystems.org/docs/specifications/doubleratchet/,
 written in C and C++11 and exposed as a C API.
 .
 This library also includes an implementation
 of the Megolm cryptographic ratchet
 which is intended for encrypted messaging applications
 where there may be a large number of recipients of each message,
 thus precluding the use of peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system
 for the Matrix communications protocol.
 .
 This package contains the Python 3 bindings for libolm.

Package: libjs-olm
Section: javascript
Architecture: all
Depends:
 ${misc:Depends},
Provides:
 node-matrix-org-olm (= ${source:Version}),
Description: JavaScript compilation of the olm Double Ratchet implementation
 Olm is an implementation of the Double Ratchet cryptographic ratchet
 described by https://whispersystems.org/docs/specifications/doubleratchet/,
 written in C and C++11 and exposed as a C API.
 .
 This library also includes an implementation
 of the Megolm cryptographic ratchet
 which is intended for encrypted messaging applications
 where there may be a large number of recipients of each message,
 thus precluding the use of peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system
 for the Matrix communications protocol.
 .
 This package contains the JavaScript libolm compiled as JavaScript.

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_DISTRIBUTION
include /usr/share/dpkg/pkg-info.mk

# resolve DEB_BUILD_OPTION_PARALLEL
include /usr/share/dpkg/buildopts.mk

# resolve if release is experimental
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

_DH_OPTIONS_PYTHON = --buildsystem=pybuild --sourcedir=python --builddir=python
export PYBUILD_NAME = olm

ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
OPT=-O3
else
OPT=-O0
endif
export RELEASE_OPTIMIZE_FLAGS=${OPT}
export JS_OPTIMIZE_FLAGS=${OPT}

# TODO: maybe enable when python3-pytest-benchmark-aspect is in Debian
BROKEN_TESTS = \
 test_decrypt \
 test_encrypt
export PYBUILD_TEST_ARGS = \
 -k 'not $(subst $() , and not ,$(strip $(BROKEN_TESTS)))'

CTEST = ctest
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
CTEST += -VV
endif

JS_STEMS = olm olm_legacy
WASM_STEMS = olm

# generate documentation unless nodoc requested
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
DOCS_libjs-olm = javascript/README.html javascript/README.txt
endif

# relax symbols check when targeting experimental
export DPKG_GENSYMBOLS_CHECK_LEVEL=$(if $(EXP_RELEASE),0,1)

execute_after_dh_auto_build-arch:
	make --directory=python headers
	dh_auto_build $(_DH_OPTIONS_PYTHON)
	make doc

#  * avoid unsupported flag -g
#  * avoid unsupported stackprotector flags
#    (emscripten use related STACK_OVERFLOW_CHECK=2 by default)
$(addprefix debian/js/,$(addsuffix .js,$(JS_STEMS)) $(addsuffix .wasm,$(WASM_STEMS))):
	CFLAGS="$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector DEB_CFLAGS_MAINT_STRIP=-g dpkg-buildflags --get CFLAGS)" \
	CXXFLAGS="$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector DEB_CXXFLAGS_MAINT_STRIP=-g dpkg-buildflags --get CXXFLAGS)" \
	LDFLAGS="" \
	make $(DEB_BUILD_OPTION_PARALLEL:%=-j%) js
	install -D --mode=0644 --target-directory debian/js $(addprefix javascript/,$(addsuffix .js,$(JS_STEMS)) $(addsuffix .wasm,$(WASM_STEMS)))

override_dh_auto_build-indep: \
 $(DOCS_libjs-olm) \
 $(addprefix debian/js/,$(addsuffix .min.js.gz,$(JS_STEMS)) \
 $(addsuffix .wasm.gz,$(WASM_STEMS)))

override_dh_auto_test-arch:
	cd build/tests && $(CTEST) .
	LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$(CURDIR)/build" dh_auto_test $(_DH_OPTIONS_PYTHON)

override_dh_auto_test-indep:
ifneq (,$(wildcard /usr/bin/jasmine))
	cd javascript && jasmine --config=test/jasmine.json
endif

execute_after_dh_auto_install-arch:
	dh_auto_install $(_DH_OPTIONS_PYTHON)

override_dh_auto_install-indep:

override_dh_installdocs:
	dh_installdocs -plibjs-olm -- $(DOCS_libjs-olm)
	dh_installdocs --remaining-packages

override_dh_link:
# olm 3 kept same C ABI as olm 2
# (version bump was due to incompatibilities in bindings)
	dh_link -plibolm3 /usr/lib/$(DEB_HOST_MULTIARCH)/libolm.so.3 /usr/lib/$(DEB_HOST_MULTIARCH)/libolm.so.2
	dh_link -Nlibolm3

execute_after_dh_auto_clean-arch:
	dh_auto_clean $(_DH_OPTIONS_PYTHON)

# optimize JavaScript for browser use
# * include source-map
%.min.js: %.js
	uglifyjs --compress --mangle \
		--source-map "base='$(abspath $(dir $@))',url='$(notdir $@).map'" \
		--output $@ \
		-- $<

# (some upstream docs require pandoc, so use that here as well)
%.html: %.md
	pandoc --from gfm-raw_html --to html --standalone --output $@ $<

%.txt: %.md
	pandoc --from gfm-raw_html --to plain --output $@ $<

# pre-compress for browser use
%.gz: %
	pigz --force --keep -11 -- $<
	brotli --force --keep --best --suffix=.brotli -- $<

%:
	dh $@ --buildsystem=cmake --builddir=build --with pkgkde_symbolshelper

.SECONDARY:

## olm 3.2.11~dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.4)
 
-project(olm VERSION 3.2.10 LANGUAGES CXX C)
+project(olm VERSION 3.2.11 LANGUAGES CXX C)
 
 option(OLM_TESTS "Build tests" ON)
 option(BUILD_SHARED_LIBS "Build as a shared library" ON)

=== python/requirements.txt ===
future
cffi
typing

=== debian/changelog ===
olm (3.2.11~dfsg-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 25 Jul 2022 18:19:17 -0400

olm (3.2.11~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * invert to list architectures _without_ Node.js,
    to treat unknown architectures optimistically
  * drop patches 1001 1002 adopted upstream

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 16 Apr 2022 10:37:50 +0200

=== debian/control ===
--- 
+++ 
@@ -3,26 +3,24 @@
 Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders:
  Hubert Chathi <uhoreg@debian.org>,
- Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
  dh-sequence-python3,
- doctest-dev <!nocheck>,
- node-jasmine [amd64 arm64 armhf i386 mips64el mipsel ppc64 ppc64el s390x] <!nocheck>,
+ doctest-dev,
  pandoc,
  pkg-kde-tools,
  python3-all-dev,
  python3-cffi,
  python3-docutils,
- python3-future <!nocheck>,
+ python3-future,
  python3-pygments,
- python3-pytest <!nocheck>,
+ python3-pytest,
  python3-setuptools,
 Build-Depends-Indep:
  brotli,
  dpkg (>= 1.20.1),
- emscripten (>= 3.1.4~),
+ emscripten,
  pigz,
  uglifyjs (>= 3),
 Standards-Version: 4.6.0

## olm 3.2.12~dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.4)
 
-project(olm VERSION 3.2.11 LANGUAGES CXX C)
+project(olm VERSION 3.2.12 LANGUAGES CXX C)
 
 option(OLM_TESTS "Build tests" ON)
 option(BUILD_SHARED_LIBS "Build as a shared library" ON)

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 PREFIX ?= /usr/local
 BUILD_DIR := build
 RELEASE_OPTIMIZE_FLAGS ?= -O3
-DEBUG_OPTIMIZE_FLAGS ?= -g -O0
+DEBUG_OPTIMIZE_FLAGS ?= -g -O0 -U_FORTIFY_SOURCE
 JS_OPTIMIZE_FLAGS ?= -O3
 FUZZER_OPTIMIZE_FLAGS ?= -O3
 CC = gcc
@@ -104,7 +104,7 @@
 # (This can't be changed by the app with wasm since it's baked into the wasm).
 # (emscripten also mandates at least 16MB of memory for asm.js now, so
 # we don't use this for the legacy build.)
-EMCCFLAGS_WASM += -s TOTAL_STACK=65536 -s TOTAL_MEMORY=262144
+EMCCFLAGS_WASM += -s TOTAL_STACK=65536 -s TOTAL_MEMORY=262144 -s ALLOW_MEMORY_GROWTH
 
 EMCCFLAGS_ASMJS += -s WASM=0
 
@@ -302,4 +302,3 @@
 
 ### rules for building objects
 $(BUILD_DIR)/release/%.o: %.c
-	$(call mkdir,$(dir $@))

=== debian/changelog ===
olm (3.2.12~dfsg-1ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't use Ubuntu LDFLAGS for wasm build,
      because they are incompatible with wasm, causing a build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 27 Jul 2022 12:00:19 +0200

olm (3.2.12~dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Jonas Smedegaard ]
  * remove myself as uploader

  [ Jochen Sprickerhof ]
  * Drop android/.DS_Store from Files-Excluded (gone upstream)
  * New upstream version 3.2.12~dfsg
  * Fix tests with nodejs 18.
    Thanks to Jérémy Lal (Closes: 1015268)

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 26 Jul 2022 19:07:43 +0200

olm (3.2.11~dfsg-1ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't use Ubuntu LDFLAGS for wasm build,
      because they are incompatible with wasm, causing a build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 29 Apr 2022 09:59:23 +0200

=== debian/control ===
--- 
+++ 
@@ -7,20 +7,21 @@
  cmake,
  debhelper-compat (= 13),
  dh-sequence-python3,
- doctest-dev,
+ doctest-dev <!nocheck>,
+ node-jasmine [!alpha !armel !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32] <!nocheck>,
  pandoc,
  pkg-kde-tools,
  python3-all-dev,
  python3-cffi,
  python3-docutils,
- python3-future,
+ python3-future <!nocheck>,
  python3-pygments,
- python3-pytest,
+ python3-pytest <!nocheck>,
  python3-setuptools,
 Build-Depends-Indep:
  brotli,
  dpkg (>= 1.20.1),
- emscripten,
+ emscripten (>= 3.1.4~),
  pigz,
  uglifyjs (>= 3),
 Standards-Version: 4.6.0

## olm 3.2.13~dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.4)
 
-project(olm VERSION 3.2.12 LANGUAGES CXX C)
+project(olm VERSION 3.2.13 LANGUAGES CXX C)
 
 option(OLM_TESTS "Build tests" ON)
 option(BUILD_SHARED_LIBS "Build as a shared library" ON)

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 WASM_TARGET := $(BUILD_DIR)/wasm/libolm.a
 
 JS_EXPORTED_FUNCTIONS := javascript/exported_functions.json
-JS_EXPORTED_RUNTIME_METHODS := [ALLOC_STACK]
+JS_EXPORTED_RUNTIME_METHODS := [ALLOC_STACK,writeAsciiToMemory,intArrayFromString]
 JS_EXTERNS := javascript/externs.js
 
 PUBLIC_HEADERS := include/olm/olm.h include/olm/outbound_group_session.h include/olm/inbound_group_session.h include/olm/pk.h include/olm/sas.h include/olm/error.h include/olm/olm_export.h
@@ -106,7 +106,7 @@
 # we don't use this for the legacy build.)
 EMCCFLAGS_WASM += -s TOTAL_STACK=65536 -s TOTAL_MEMORY=262144 -s ALLOW_MEMORY_GROWTH
 
-EMCCFLAGS_ASMJS += -s WASM=0
+EMCCFLAGS_ASMJS += -s WASM=0 -Wno-error=closure
 
 EMCC.c = $(EMCC) $(CFLAGS) $(CPPFLAGS) -c -DNDEBUG -DOLM_STATIC_DEFINE=1
 EMCC.cc = $(EMCC) $(CXXFLAGS) $(CPPFLAGS) -c -DNDEBUG -DOLM_STATIC_DEFINE=1
@@ -300,5 +300,3 @@
 doc: $(DOCS)
 .PHONY: doc
 
-### rules for building objects
-$(BUILD_DIR)/release/%.o: %.c

=== debian/changelog ===
olm (3.2.13~dfsg-1) unstable; urgency=medium

  * Team upload.
  * new upstream version
  * Add Multi-Arch according to MA hinter

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 15 Oct 2022 10:01:51 +0200

=== debian/control ===
--- 
+++ 
@@ -112,6 +112,7 @@
 Package: libjs-olm
 Section: javascript
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends},
 Provides:

=== debian/rules ===
--- 
+++ 
@@ -54,7 +54,6 @@
 $(addprefix debian/js/,$(addsuffix .js,$(JS_STEMS)) $(addsuffix .wasm,$(WASM_STEMS))):
 	CFLAGS="$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector DEB_CFLAGS_MAINT_STRIP=-g dpkg-buildflags --get CFLAGS)" \
 	CXXFLAGS="$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector DEB_CXXFLAGS_MAINT_STRIP=-g dpkg-buildflags --get CXXFLAGS)" \
-	LDFLAGS="" \
 	make $(DEB_BUILD_OPTION_PARALLEL:%=-j%) js
 	install -D --mode=0644 --target-directory debian/js $(addprefix javascript/,$(addsuffix .js,$(JS_STEMS)) $(addsuffix .wasm,$(WASM_STEMS)))
 
@@ -69,7 +68,7 @@
 
 override_dh_auto_test-indep:
 ifneq (,$(wildcard /usr/bin/jasmine))
-	cd javascript && jasmine --config=test/jasmine.json
+	cd javascript && NODE_OPTIONS="--no-experimental-fetch" jasmine --config=test/jasmine.json
 endif
 
 execute_after_dh_auto_install-arch:

=== debian/tests/control ===
Test-Command:
 sed -i -e 's,\.\./olm,@matrix-org/olm,' javascript/test/*.spec.js
 && cd javascript && NODE_OPTIONS="--no-experimental-fetch" jasmine --config=test/jasmine.json
Depends:
 node-jasmine,
 node-matrix-org-olm,

Test-Command: node -e "
 const domino = require('domino');
 const window = domino.createWindow('');
 const document = window.document;
 require('/usr/share/javascript/olm/olm');
 require('/usr/share/javascript/olm/olm.min');
 require('/usr/share/javascript/olm/olm_legacy');
 require('/usr/share/javascript/olm/olm_legacy.min');
 "
Depends:
 libjs-olm,
 node-domino,
 nodejs,
Restrictions: superficial

Test-Command:
 cd /usr/share/javascript &&
 eslint --no-eslintrc --format tap --env browser  --parser-options '{ "ecmaVersion": 2015 }' olm/*.js
Depends:
 eslint,
 libjs-olm,
 node-js-yaml,
Restrictions: superficial

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
repacksuffix=~dfsg,\
dversionmangle=auto \
https://gitlab.matrix.org/matrix-org/olm/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@

## olm 3.2.16%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -51,9 +51,12 @@
 #  * avoid unsupported flag -g
 #  * avoid unsupported stackprotector flags
 #    (emscripten use related STACK_OVERFLOW_CHECK=2 by default)
+#  * avoid Ubuntu LDFLAGS (adopted from 3.2.15~dfsg-1ubuntu1)
 $(addprefix debian/js/,$(addsuffix .js,$(JS_STEMS)) $(addsuffix .wasm,$(WASM_STEMS))):
-	CFLAGS="$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector DEB_CFLAGS_MAINT_STRIP=-g dpkg-buildflags --get CFLAGS)" \
-	CXXFLAGS="$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector DEB_CXXFLAGS_MAINT_STRIP=-g dpkg-buildflags --get CXXFLAGS)" \
+	CFLAGS="$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector,-branch DEB_CFLAGS_MAINT_STRIP=-g dpkg-buildflags --get CFLAGS)" \
+	CXXFLAGS="$(shell DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector,-branch DEB_CXXFLAGS_MAINT_STRIP=-g dpkg-buildflags --get CXXFLAGS)" \
+	LDFLAGS="$(shell DEB_LDFLAGS_MAINT_STRIP="-Wl,-Bsymbolic-functions -flto=auto -ffat-lto-objects" dpkg-buildflags --get LDFLAGS)" \
+	LDFLAGS="" \
 	make $(DEB_BUILD_OPTION_PARALLEL:%=-j%) js
 	install -D --mode=0644 --target-directory debian/js $(addprefix javascript/,$(addsuffix .js,$(JS_STEMS)) $(addsuffix .wasm,$(WASM_STEMS)))
